<?php
namespace Services;

class SendEmailService {
    protected $crudService;
    protected $smtpUtil;
    protected $environment;
    private $supUtilities;
    
    public function __construct($smtpUtil, $supUtilities, $environment) {
        $this->smtpUtil = $smtpUtil;
        $this->supUtilities = $supUtilities;
        $this->environment = $environment;
    }
    
    public function sendEMail($params, $message) {
        // if(isset($params['NMOPERADOR_FROM'])) {
        //     $this->smtpUtil->setFromName($params['NMOPERADOR_FROM']);
        // }
        // $this->smtpUtil->setNmAddress($params['NMOPERADOR']);
        // $this->smtpUtil->setSubject($message['ASSUNTO']);
        // $this->smtpUtil->sendMail($message['HTML'], $params['DSEMAILOPER']);
        
        $this->supUtilities->enviaEmail('', $message['ASSUNTO'], $params['NMOPERADOR'], $message['HTML'], $params['DSEMAILOPER']);
    }
    
    public function sendMailSupplyTek($email, $idAplicativo, $filial)
    {
        try {
            $cdfilial = $filial ? $filial : $this->environment->getCdfilial();
            $messageSendMail = $this->supUtilities->messageSendMail($cdfilial, $email["SUBJECT"], $email["CONTENT"], $idAplicativo);
            if(isset($email["ATTACHMENT"])){
                $this->supUtilities->enviaEmail("", $email["SUBJECT"], $email["RECIPIENT"], $messageSendMail, $email["RECIPIENT"], $email["ATTACHMENT"], $email["ATTACHMENTNAME"]);                
            } else {
                $this->supUtilities->enviaEmail("", $email["SUBJECT"], $email["RECIPIENT"], $messageSendMail, $email["RECIPIENT"], false, false, false, $cdfilial);
            }            
        } catch (\Exception $e) {
            if($email["SUBJECT"] == 'Reprovação de Alçada'){
                throw new \Exception('Pedido reprovado com sucesso, porém não foi possível enviar o e-mail de notificação.', 9937);
            } else{
                throw new \Exception('Pedido aprovado com sucesso, porém não foi possível enviar o e-mail de notificação.', 9937);
            }
        }
    }
    
    public function getMessage($params) {
        $JUSTIFICATIVA = '';
        $params['IDCLASSIFIC'] = self::defineClassific($params['IDCLASSIFIC']);
        $params['IDTPDEMANDA'] = self::defineDemanda($params['IDTPDEMANDA']);
        
        switch ($params["MOTIVO"]) {
            case 'APROVACAO_ALCADA':
                $img         = $this->getImage('aprovacao.png');
                $title       = 'Aprovação de Alçada';
                $mailFrom    = $params['DSEMAILOPER_FROM'];
                $nameAddress = $params['NMOPERADOR'];
                $message     = 'Segue os dados da demanda para a sua aprovação:';
            break;
            
            case 'REPROVACAO_ALCADA':
                $img           = $this->getImage('reprovacao.png');
                $title         = 'Reprovação de Alçada';
                $mailFrom      = $params['DSEMAILOPER_FROM'];
                $nameAddress   = $params['NMOPERADOR'];
                $message       = "Infelizmente a demanda abaixo foi reprovada por&nbsp;" . $params['NMOPERADOR_FROM'] . "";
                $JUSTIFICATIVA = '<li>Justificativa:&nbsp;' . $params['JUSTIFICATIVA'] . '</li>';
            break;
            
            case 'APROVACAO_ALCADA_LANCAMENTO':
                $img         = $this->getImage('aprovacao.png');
                $title       = 'Aprovação de Alçada';
                $nameAddress = $params['NMOPERADOR'];
                $message     = 'Segue os dados da demanda para a sua aprovação:';
                $mailFrom      = '';
                $JUSTIFICATIVA = '';
            break;
            
            case 'LIBERACAO_DEMANDA':
                $img         = $this->getImage('aprovacao.png');
                $title       = 'Liberação de Demanda';
                $nameAddress = $params['NMOPERADOR'];
                $message       = "A seguinte demanda foi aprovada por todos os seus aprovadores e esta liberada para consumo.";
                $mailFrom      = '';
                $JUSTIFICATIVA = '';
            break;

            case 'ERRO_IMPORTACAO':
                $img = '';
                $title = 'Erro de Importação';
                $nameAddress = $params['NMOPERADOR'];
                $message = 'Ocorreram erros durante a importação da seguinte AF:';
                $mailFrom = '';
                $JUSTIFICATIVA = '';
        }
        return array(
            'HTML' => "<!DOCTYPE html> <html> <head> <meta charset='UTF-8'> <style> body { margin: 0px; display: block; padding: 0px; margin: 0px; font-family: Arial, sans-serif; } .containerGeral { background-color: #FFFFFF; } .linha { width: 590px; display: table; } .cabecalho { background-color: #FFFFFF; padding: 5px 0px 5px 0px; } .email { color: #2D68C4; font-size: 14px; text-align: right; padding: 10px 30px 0 0; } .tipoEmail { background-color: #f5faff; } .conteudo { display: table-row; width: 550px; background-color: #FFFFFF; } .rodape { background-color: #2D68C4; } .titulo { font-weight: bold; width: 500px; border-bottom: 1px solid #2D68C4; } .lista { list-style-type: none; padding-left: 10px; } .itensLista { float: left; width: 60px; font-weight: bold; } .logomarca { padding: 15px; vertical-align: middle; } #assunto { padding: 25px 50px 25px 50px; vertical-align: middle; text-align: left; color: #00305A; font-size: 23px; } #tipoAssunto { padding: 20px 0px 20px 30px; } #borda { padding: 0px 20px 20px 20px; vertical-align: middle; width: 510px; } #quadroConteudo { width: 550px; line-height: 150%; font-size: 14px; padding: 20px; color: #726969; } #direitosReservados { padding: 20px 0px 20px 0px; color: #FFFFFF; font-size: 15px; text-align: center; } </style> </head> <body> <center class='containerGeral'> <table cellpadding='0' cellspacing='0'> <tbody> <tr class='linha cabecalho'> <td class='logomarca'> <img id='logo' width='220' src='" . $this->getImage('logotipo.png') . "'> </td> </tr> <tr class='linha tipoEmail'> <td id='tipoAssunto'> <img src='" . $img . "'> </td> <td id='assunto'> <p>" . $title . "</p> </td> </tr> <div id='quadroConteudo'> <tr class='linha conteudo'> <td id='borda'> <table cellpadding='0' cellspacing='0' style='background-color: #F7F7F7'> <tbody> <tr> <td> <div> <b>Olá,&nbsp;" . $nameAddress . "</b> <p>" . $message . "</p> <ul> <li>Demanda:&nbsp;" . $params['IDTPDEMANDA'] . "</li> <li>Número:&nbsp;" . $params['NRAUTOFORN'] . "</li> <li>Unidade:&nbsp;" . $params['NMFILIAL'] . "</li> <li>Alçada:&nbsp;" . $params['NMALCADA'] . "</li> <li>Classificação:&nbsp;" . $params['IDCLASSIFIC'] . "</li> " . $JUSTIFICATIVA . " </ul> <br> <p>Veja mais informações sobre essa demanda em:</p> <br> <div style='width:50%; float:right;'> <a href=#> <img id='logo' width='150' src='" . $this->getImage('logotipo_tecfood.png') . "'> </a> </div> <div style='width: 50%; float:left;'> <a href='https://play.google.com/store/apps/details?id=br.com.tecfood.Approve'> <img id='logo' width='150' href=# src='" . $this->getImage('logotipo_approve.png') . "'> </a> </div> </div> </td> </tr> </tbody> </table> </td> </tr> </div> <tr class='linha rodape'> <td id='direitosReservados'> <p>Todos os direitos reservados.</p> </td> </tr> </tbody> </table> </body> </html>",
            'ASSUNTO' => $title
        );
    }
    
    public function defineClassific($IDCLASSIFIC) {
        switch ($IDCLASSIFIC) {
            case 'PADRAO':
                return 'Padrão';
            break;
            
            case 'FORA_ORCAMENTO':
                return 'Fora do Orçamento';
            break;
            
            case 'EXTRA':
                return 'Extra';
            break;
        }
    }
    
    public function defineDemanda($IDTPDEMANDA) {
        switch ($IDTPDEMANDA) {
            case 'AF':
                return 'Autorização de Fornecimento';
            break;
        }
    }

    public function getErrorReportMessage($cdSupplier, $supplierName, $orders) {
        $title = "Erro de Importação";
        $orderMessage = self::getOrderMessage($orders);
        $message = "<!DOCTYPE html> <html> <head> <meta charset='UTF-8'> <style> body { margin: 0px; display: block; padding: 0px; margin: 0px; font-family: Arial, sans-serif; } .containerGeral { background-color: #FFFFFF; } .linha { width: 590px; display: table; } .cabecalho { background-color: #FFFFFF; padding: 5px 0px 5px 0px; } .email { color: #2D68C4; font-size: 14px; text-align: right; padding: 10px 30px 0 0; } .tipoEmail { background-color: #f5faff; } .conteudo { display: table-row; width: 550px; background-color: #FFFFFF; } .rodape { background-color: #2D68C4; } .titulo { font-weight: bold; width: 500px; border-bottom: 1px solid #2D68C4; } .lista { list-style-type: none; padding-left: 10px; } .itensLista { float: left; width: 60px; font-weight: bold; } .logomarca { padding: 15px; vertical-align: middle; } #assunto { padding: 25px 50px 25px 50px; vertical-align: middle; text-align: left; color: #00305A; font-size: 23px; } #tipoAssunto { padding: 20px 0px 20px 30px; } #borda { padding: 0px 20px 20px 20px; vertical-align: middle; width: 510px; } #quadroConteudo { width: 550px; line-height: 150%; font-size: 14px; padding: 20px; color: #726969; } #direitosReservados { padding: 20px 0px 20px 0px; color: #FFFFFF; font-size: 15px; text-align: center; } li { list-style-type: none } img { width: 100px; }</style> </head> <body> <center class='containerGeral'> <table cellpadding='0' cellspacing='0'> <tbody> <tr class='linha cabecalho'> <td class='logomarca'> <img id='logo' width='220' src='" . $this->getImage('logotipo.png') . "'> </td> </tr> <tr class='linha tipoEmail'> <td id='tipoAssunto'> <img src='" . $this->getImage('warning.png') . "'> </td> <td id='assunto'> <p>$title</p> </td> </tr> <div id='quadroConteudo'> <tr class='linha conteudo'> <td id='borda'> <p>Ocorram erros durante a importação automática da seguinte AF:</p> <ul> <li>Fornecedor: $supplierName</li> $orderMessage </ul> </td> </tr> </div> <tr class='linha rodape'> <td id='direitosReservados'> <p>Todos os direitos reservados.</p> </td> </tr> </tbody> </table> </body> </html>";
        return [
            'HTML' => $message,
            'ASSUNTO' => $title,
        ];
    }

    private function getOrderMessage($orders) {
        $orderMessage = "";
        foreach($orders as $order) {
            $orderMessage = $orderMessage."<br><li>Número no pedido:".$order['numOrder']."</li><li><div class='report-link'><a href='".$order['report']."'>Para visualizar o relatório de erros, clique aqui!</a></div></li>";
        }
        return $orderMessage;
    }
    
    /**
     * @Solução Temporária
     * Alteramos o link direto da imagem pelo arquivo convertido em base64
     * porque o servidor de midiatest teve seu acesso restrito a IPs da Teknisa.
     * 
     * Utilizar uma solução que consuma a imagem do FileServer do cliente pode
     * ser o mais ideal.
     */
    private function getImage($fileName)
    {
        $extension    = explode('.', $fileName)[1];
        $prefix       = 'data:image/' . $extension . ';base64, ';
        
        $imageDir     = $this->getImagesDirectory();
        $imageData    = file_get_contents($imageDir . $fileName);
        $encodedImage = base64_encode($imageData);
        
        return $prefix . $encodedImage;
    }
    
    private function getImagesDirectory()
    {
        $currentDir = getcwd();
        $imagesDir = 'modules/sup/mobile/assets/images/';
        
        if (!$currentDir) {
            throw new \Exception('SendEmail - Não é possível obter o diretório atual.');
        }
        
        $paths = explode('modules' , $currentDir);
        $commonPath = array_shift($paths);
        
        $newPath = $commonPath . $imagesDir;

        if (strpos($newPath, "//") !== false) {
            $newPath =  str_replace("//", "/", $newPath);
        }
        
        return $newPath;
    }
}