CREATE OR REPLACE PROCEDURE FCT_COPIA_FORM_PRECO_ITCONT (
    P_NRFORMPRECOSERVICO IN NUMBER,
    P_NRORG IN NUMBER,
    P_OPERADOR IN VARCHAR2,
    P_NRSEQCONTRATO IN FCT_CONTRATO.NRSEQCONTRATO%TYPE,
    P_NRITEMOCONTRATO IN FCT_ITEMCONTRATO.NRITEMOCONTRATO%TYPE,
    P_NRCALCFORMPRECSERV IN NUMBER DEFAULT NULL)
AS

    V_NRCALCFORMPRECSERV FCT_CALCFORMPRECSERV.NRCALCFORMPRECSERV%TYPE;
    V_IDITEMCALCULOPAI FCT_CALCFORMPRECSERV.IDITEMCALCULO%TYPE;
    V_REFERENCIA VARCHAR2(500);
    V_PAI NUMBER;

BEGIN
    FOR C_CALC IN (SELECT NRCALCFORMPRECSERV, NRFORMPRECOSERVICO, IDORDENACAO, IDITEMCALCULO, IDELEMENTO,
                           NRCALCFORMPRECSERVPAI, DSREFECALCULO, CDHABILITSERV, IDTIPOCALCULO,
                           DSEXPRESSAOCALC, VRPERCCALCULO, VRUNITARIO, QTCALCULO, IDUSAMEDIDA,
                           CDTPMEDIDASERV, QTMEDIDACALC, VRTOTAL
                      FROM FCT_CALCFORMPRECSERV
                      WHERE NRFORMPRECOSERVICO = P_NRFORMPRECOSERVICO
                       AND NRORG = P_NRORG
                       AND P_NRCALCFORMPRECSERV IS NOT NULL
                        CONNECT BY PRIOR NRCALCFORMPRECSERV = NRCALCFORMPRECSERVPAI
                        START WITH NRCALCFORMPRECSERV = P_NRCALCFORMPRECSERV
                    UNION ALL
                    SELECT NRCALCFORMPRECSERV, NRFORMPRECOSERVICO, IDORDENACAO, IDITEMCALCULO, IDELEMENTO,
                           NRCALCFORMPRECSERVPAI, DSREFECALCULO, CDHABILITSERV, IDTIPOCALCULO,
                           DSEXPRESSAOCALC, VRPERCCALCULO, VRUNITARIO, QTCALCULO, IDUSAMEDIDA,
                           CDTPMEDIDASERV, QTMEDIDACALC, VRTOTAL
                      FROM FCT_CALCFORMPRECSERV
                      WHERE NRFORMPRECOSERVICO = P_NRFORMPRECOSERVICO
                       AND NRORG = P_NRORG
                       AND P_NRCALCFORMPRECSERV IS NULL
                       ORDER BY IDORDENACAO) LOOP
        BEGIN
            SELECT IDITEMCALCULO
              INTO V_IDITEMCALCULOPAI
              FROM FCT_CALCFORMPRECSERV
             WHERE NRCALCFORMPRECSERV = C_CALC.NRCALCFORMPRECSERVPAI
               AND NRFORMPRECOSERVICO = P_NRFORMPRECOSERVICO
               AND NRORG = P_NRORG;
        EXCEPTION
            WHEN NO_DATA_FOUND THEN
              V_IDITEMCALCULOPAI := NULL;
        END;

        IF V_IDITEMCALCULOPAI IS NOT NULL THEN
            V_REFERENCIA := C_CALC.DSREFECALCULO||'_PAI_'||V_IDITEMCALCULOPAI;
        ELSE
            V_REFERENCIA := C_CALC.DSREFECALCULO;
        END IF;

        NOVO_CODIGO_SC('FCT_CALCFORMPRECSERV_ITCONT', V_NRCALCFORMPRECSERV, 1, P_NRORG);
        INSERT INTO FCT_CALCFORMPRECSERV_ITCONT (NRCALCFORMPRECSERV, NRFORMPRECOSERVICO, IDORDENACAO, IDITEMCALCULO,
                                                IDELEMENTO, NRCALCFORMPRECSERVPAI, DSREFECALCULO, CDHABILITSERV,
                                                IDTIPOCALCULO, DSEXPRESSAOCALC, VRPERCCALCULO, VRUNITARIO, QTCALCULO,
                                                IDUSAMEDIDA, CDTPMEDIDASERV, QTMEDIDACALC, VRTOTAL, NRORG, DTINCLUSAO,
                                                NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO, NRSEQCONTRATO, NRITEMOCONTRATO)
        VALUES (V_NRCALCFORMPRECSERV, P_NRFORMPRECOSERVICO, C_CALC.IDORDENACAO, C_CALC.IDITEMCALCULO,
                C_CALC.IDELEMENTO, C_CALC.NRCALCFORMPRECSERVPAI, V_REFERENCIA, C_CALC.CDHABILITSERV,
                C_CALC.IDTIPOCALCULO, C_CALC.DSEXPRESSAOCALC, C_CALC.VRPERCCALCULO, C_CALC.VRUNITARIO,
                C_CALC.QTCALCULO,  C_CALC.IDUSAMEDIDA,  C_CALC.CDTPMEDIDASERV, C_CALC.QTMEDIDACALC,
                C_CALC.VRTOTAL, P_NRORG, SYSDATE, P_NRORG, P_OPERADOR, 'S', P_NRSEQCONTRATO, P_NRITEMOCONTRATO);
    END LOOP;

    FOR C_CALCPAI IN (SELECT NRCALCFORMPRECSERV, NRFORMPRECOSERVICO,
                             SUBSTR(DSREFECALCULO, INSTR(DSREFECALCULO, '_PAI_')+5) AS IDPAI,
                             SUBSTR(DSREFECALCULO, 0, INSTR(DSREFECALCULO, '_PAI_')-1) AS REFERENCIA
                          FROM FCT_CALCFORMPRECSERV_ITCONT
                         WHERE NRFORMPRECOSERVICO = P_NRFORMPRECOSERVICO
                           AND NRORG = P_NRORG
                           AND NRSEQCONTRATO = P_NRSEQCONTRATO
                           AND (NRITEMOCONTRATO IS NULL
                                OR NRITEMOCONTRATO = P_NRITEMOCONTRATO)
                           AND NRCALCFORMPRECSERVPAI IS NOT NULL
                           ORDER BY IDORDENACAO) LOOP

        BEGIN
            SELECT NRCALCFORMPRECSERV
              INTO V_PAI
              FROM FCT_CALCFORMPRECSERV_ITCONT
             WHERE IDITEMCALCULO = C_CALCPAI.IDPAI
               AND NRSEQCONTRATO = P_NRSEQCONTRATO
               AND (NRITEMOCONTRATO IS NULL
                        OR NRITEMOCONTRATO = P_NRITEMOCONTRATO)
               AND NRFORMPRECOSERVICO = P_NRFORMPRECOSERVICO
               AND NRORG = P_NRORG;
        EXCEPTION WHEN NO_DATA_FOUND THEN
            V_PAI := NULL;
        END;

        UPDATE FCT_CALCFORMPRECSERV_ITCONT
           SET NRCALCFORMPRECSERVPAI  =  V_PAI,
               DSREFECALCULO = C_CALCPAI.REFERENCIA
         WHERE NRCALCFORMPRECSERV = C_CALCPAI.NRCALCFORMPRECSERV
           AND NRFORMPRECOSERVICO = P_NRFORMPRECOSERVICO
           AND NRORG = P_NRORG;
    END LOOP;
    COMMIT;
END;
/